%
% HTL Mössingerstraße
% Diploma thesis style
%
% Editor: Daniel Wischounig-Strucl
% Small changes by Stefan Pisjak
%
% Adaptation of the Stanford University PhD thesis style.
%
% Modification history:

%\ProvidesPackage{htlthesis}[2016/03/29 HTL diploma thesis style]
%\DeclareOption{chapterinhead}{}

% Reduntant package, see @encoding below
% \usepackage[utf8]{inputenc}
\usepackage{htlchapter}

\typeout{Document Style Option `htlthesis'.}


\long\def\comment#1{}
\comment{

}



\RequirePackage{suthesis-2e}
\RequirePackage{expl3} % http://tex.stackexchange.com/questions/438/how-to-test-whether-next-token-on-input-stream-is-catcode-10/442#442
\ExplSyntaxOn
\newcommand\latinabbrev[1]{
  \peek_meaning:NTF . {% Same as \@ifnextchar
    #1\@}
  { \peek_catcode:NTF a {% Check whether next char has same catcode as \'a, i.e., is a letter
      #1.\@ }
    {#1.\@}}}
\ExplSyntaxOff


% Graphics package
\usepackage{floatrow} % this automatically centers all floats
%\RequirePackage{float}
\floatplacement{table}{hbtp} % default placement for tables
\floatplacement{figure}{hbtp} % default placement for figures
\floatstyle{plain}
\usepackage{epsfig}
\usepackage{graphicx}
\usepackage{fancybox}
\DeclareGraphicsExtensions{.pdf,.png,.jpg}
\graphicspath{{./graphics/}}
%\usepackage{subfig}
\usepackage{caption}
\usepackage{subcaption}
\usepackage[font=footnotesize, labelfont={bf}, margin=1cm]{caption}

%multicolumn content (remove if not required)
\usepackage{multicol}
\setlength{\columnsep}{1.5em}
\setlength{\headheight}{24pt}

%encoding
%--------------------------------------
\usepackage[utf8]{inputenc}
\usepackage[T1]{fontenc}
%--------------------------------------

%German-specific commands
%--------------------------------------
\usepackage[main=ngerman,english]{babel}
\usepackage{csquotes}
%--------------------------------------

%Hyphenation rules
%--------------------------------------
\usepackage{hyphenat}
% Example
\hyphenation{Mathe-matik wieder-gewinnen}
%--------------------------------------

\usepackage[shortcuts]{glossaries}
\makeglossaries

\loadglsentries{glossary}

\usepackage[backend=biber, style=alphabetic, isbn=false, url=false,
 giveninits=true]{biblatex}
%\usepackage[backend=biber,isbn=false,dateabbrev=false]{biblatex}

% For tables (Gnumeric/LaTeX2e)
\def\inputGnumericTable{}
\usepackage{array}
\usepackage{longtable}
\usepackage{calc}
\usepackage{hhline}
\usepackage{fullpage}
\usepackage{ifthen}

% Adding name to ref
\usepackage{hyperref}

% Fix heading
\usepackage[nottoc]{tocbibind}

% The first thing we do is make sure that report has been loaded.
% A common error is to try to use itecthesis as a document class.
\@ifundefined{chapter}{\@latexerr{The `htlthesis' option should be used
with the `report' document style}{You should probably read the
htlthesis documentation.}}{}

% We need 1" margins except on the binding edge, where it is 1 1/2"
% Theses are usually single-sided. However, two-sided versions are also supported.
\usepackage[a4paper]{geometry}

% https://www.sharelatex.com/learn/Page_size_and_margins

\if@twoside
  \raggedbottom
 % \evensidemargin -0.25in
 \evensidemargin -0.25in
 
\else
  \evensidemargin 0in
  %\oddsidemargin 0.5in
\fi
\oddsidemargin 0.25in
\topmargin 0pt 
\headsep .5in
\textheight 8in 
%\textwidth 6in
\headheight 24pt

\marginparwidth 2cm \marginparsep 10pt

%\if@geometry@a4paper
	\textheight 9.2in
	\textwidth 6.2in
	%\hoffset -0.2in
%\fi

% Disallow page breaks at hyphens (this will give some underfull vbox's,
% so an alternative is to use \brokenpenalty=100 and manually search
% for and fix such page breaks)
\brokenpenalty=10000

\interfootnotelinepenalty=10000

\usepackage{emptypage} % Remove header and footer on empty pages

% Redefine the macro used for floats (including figures and tables)
% so that single spacing is used.
% (Note \def\figure{\@float{figure}set single spacing} doesn't work
%  because figure has an optional argument)

%% Fix from GT (RPI, thesis.cls)  03-18-2007 ve.

%%\let\latex@xfloat=\@xfloat
%%\def\@xfloat #1[#2]{%
%%  \latex@xfloat #1[#2]%
%%  \def \baselinestretch {1}\@normalsize  %%  GT: need \@normalsize?
%%  \normalsize
%%}


% Redefine the macro used for footnotes to use single spacing
\long\def\@footnotetext#1{\insert\footins{\def\baselinestretch{1}\footnotesize
    \interlinepenalty\interfootnotelinepenalty
    \splittopskip\footnotesep
    \splitmaxdepth \dp\strutbox \floatingpenalty \@MM
    \hsize\columnwidth \@parboxrestore
   \edef\@currentlabel{\csname p@footnote\endcsname\@thefnmark}\@makefntext
    {\rule{\z@}{\footnotesep}\ignorespaces
      #1\strut}}}

% \author, \title are defined in report; here is the rest of the
% front matter defining macros
\def\male{\ma@letrue}
\def\female{\ma@lefalse}
\def\currdegree#1{\gdef\@currdegree{#1}}
\def\university#1{\gdef\@university{#1}}
\def\location#1{\gdef\@location{#1}}
\def\faculty#1{\gdef\@faculty{#1}}
\def\professor#1{\gdef\@professor{#1}}
\def\submitdate#1{\gdef\@submitdate{#1}}
\def\copyrightyear#1{\gdef\@copyrightyear{#1}} % \author, \title in report
\def\thesistype#1{\gdef\@thesistype{#1}}
% departments
\def\elti{\faculty{Elektronik und Technische Informatik}}
\def\bmgt{\faculty{Biomedizin und Gesundheitstechnik}}
\def\elet{\faculty{Elektrotechnik}}
% default settings

\newcommand{\authorpage}[1]{\def\@authorpage{#1}}

\elti
\def\@thesistype{DIPLOMARBEIT}
\def\@title{}
\def\@author{}
\def\@university{Höhere Technische Bundeslehranstalt}
\def\@address{Klagenfurt, Mössingerstraße}
\def\@location{Klagenfurt}
\def\@faculty{}
\def\@professor{}
\def\@authorpage{}
\def\@submitdate{\ifcase\the\month\or
  Januar\or Februar\or M\"arz\or April\or Mai\or Juni\or
  Juli\or August\or September\or Oktober\or November\or Dezember\fi
  \space \number\the\year}
\def\@copyrightyear{\number\the\year}

\def\dedicate#1{\dedic@tiontrue\gdef\dedication@text{#1}}

\def\nobib{\print@bibfalse}
\def\nolistoffigures{\figurespagefalse}
\def\nolistoftables{\tablespagefalse}
\def\nofront{\front@pagesfalse\figurespagefalse\tablespagefalse}

% New if constructs:    Default conditions:
\newif\iffigurespage    \figurespagetrue
\newif\iftablespage     \tablespagetrue
\newif\iffront@pages    \front@pagestrue
\newif\ifma@le          \ma@letrue
\newif\ifba@k           \ba@kfalse
\newif\ifph@d           \ph@dfalse
\newif\ifprint@bib      \print@bibtrue
\newif\ifdedic@tion     \dedic@tionfalse

\def\no@breaks#1{{\def\\{ \ignorespaces}#1}}    % disallow explicit line breaks

% Page Headers
\usepackage{fancyhdr}
\usepackage{lastpage}
%\usepackage{datetime}
\usepackage{etoolbox}

%\newdateformat{mydate}{\monthname[\THEMONTH] \THEYEAR}
%\newdateformat{footerdate}{{\THEDAY}.\,{\THEMONTH}.\,\THEYEAR}

% Define the page heading to be page number only.
\newcommand{\properpagestyle}{
        \fancyhead[LO,RE]{\includegraphics[height=14pt]{graphics/HTL/HTL_moe.pdf}}
        \fancyhead[RO,LE]{\includegraphics[height=14pt]{graphics/HTL/logo_ELTI_300.pdf}}
%        \fancyfoot[RO,LE]{\footnotesize{Page \thepage\ of \pageref{LastPage}}}
        \fancyfoot[LO,RE]{\ifdefempty{\@authorpage}{}{\footnotesize{Author: \@authorpage}}}
        %\fancyfoot[C]{\footnotesize{\let\\=\relax\@title,\twodigit{\the\day}.\,\twodigit{\the\month}.\,\the\year}}
        \pagestyle{fancy}
}

\fancypagestyle{fancyfooter}{
        \fancyhf{}
 		    \fancyfoot[RO, LE] {\footnotesize{Page \thepage\ of \pageref{LastPage}}}
        \fancyfoot[LO, RE] {\ifdefempty{\@authorpage}{}{\footnotesize{Author: \@authorpage}}}
        \fancyfoot[C]{\footnotesize{\let\\=\relax\@title,\
        \twodigit{\the\day}.\,\twodigit{\the\month}.\,\the\year}}
        \renewcommand{\headrulewidth}{0pt} % Line at the header invisible
        \pagestyle{plain}
}

\def\titlep{%
    \thispagestyle{empty}%
    \renewcommand{\baselinestretch}{0.95}
    %\oddsidemargin 0.25in
    \textwidth 6.5in
    \begin{center}
		\includegraphics[width=0.55\textwidth]{graphics/HTL/HTL_moe.pdf}
		\vskip0.15in
		\Large\uppercase\expandafter{\textbf\@university} \\
		\@address
		\vskip0.10in
		\expandafter{\@faculty}
		\vskip0.35in
      	%\hline
        \vskip0.35in
        	\Huge\textbf{\@thesistype}
        \vskip0.35in
        %\null\vskip0.35in
        \hyphenpenalty=10000\Huge\uppercase\expandafter{\@title}
        \vskip0.6in
%        \ifma@le
%        \else
%        \fi
        %\normalsize\expandafter{\@institute}
    \end{center}

    \vskip0.25in
   	\begin{minipage}[t]{0.3\linewidth}
    	\begin{flushleft}
		\noindent eingereicht von:
		\end{flushleft}
	\end{minipage}
	\begin{minipage}[t]{0.6\linewidth}
		\begin{flushleft}
		\foreach \n in \@author {\n \\ }
		\end{flushleft}
	\end{minipage}
	\vskip0.8in
	\begin{minipage}[t]{0.3\linewidth}
    	\begin{flushleft}
		 \noindent  Projektbetreuer:
		\end{flushleft}
	\end{minipage}
	\begin{minipage}[t]{0.6\linewidth}
		\begin{flushleft}
			\foreach \p in \@professor  { \p \\ }
		\end{flushleft}
	\end{minipage}
    \vfill
    \noindent \small{Diese Diplomarbeit entspricht den Standards gemäß
    dem Leitfaden zur Umsetzung der Reife- und Diplomprüfung des BM|BF in der
    letztgültigen Fassung.}
    \begin{flushright}
        \@location, \@submitdate
    \end{flushright}
    \newpage
    \textwidth 6.2in
    %\if@twoside
 	%	\oddsidemargin 0.25in
	%\else
  	%	\oddsidemargin 0.5in
	%\fi
}

% Use 1.37 times the normal baseline-to-baseline skip
\renewcommand{\baselinestretch}{1.37}

\def\signature#1#2{
	\parbox[b]{1in}{\smash{#1}\vskip10pt}
	\hfill
  \hbadness=10000
	\parbox[t]{3.7in}{
		\hrulefill
		\vskip0.2em
		\textbf{#2}
		\vskip1em
		\@location, 
    \number\the\day.
    \ifcase\the\month
      \or Januar
      \or Februar
      \or M\"arz
      \or April
      \or Mai
      \or Juni
      \or Juli
      \or August
      \or September
      \or Oktober
      \or November
      \or Dezember
    \fi
    \space 
    \number\the\year
    }
}
% English
\def\signaturepage{%
    \setcounter{page}{2}
    \begin{quotation}
        \hyphenpenalty=10000
        %\parindent=36pt
        \begin{center}
            \large {\bf Declaration of Honor}
        \end{center}
        \vskip12pt
		\normalsize
		\noindent
		I hereby confirm on my honor that I personally prepared the present academic work
		and carried out myself the activities directly involved with it. I also confirm that
		I have used no resources other than those declared. All formulations and concepts adopted
		literally or in their essential content from printed, unprinted or Internet sources have
		been cited according to the rules for academic work and identified by means of footnotes
		or other precise indications of source.\\

		\noindent The support provided during the work, including significant assistance from my
		supervisor has been indicated in full.\\

		\noindent The academic work has not been submitted to any other examination authority.
		The work is submitted in printed and electronic form. I confirm that the content of the
		digital version is completely identical to that of the printed version.\\

		\noindent I am aware that a false declaration will have legal consequences.
        \vskip1.5in
        \foreach \n in \@author { \signature{Signature:}{\n} \\
        \vskip 0.5in  }
    \end{quotation}
    \vfill\newpage\setcounter{page}{3}}

% German
\def\signaturepage{
    \setcounter{page}{2}
    \begin{quotation}
        \hyphenpenalty=10000
        %\parindent=36pt
        \begin{center}
            \large {\bf Eidesstattliche Erklärung}
        \end{center}
        \vskip12pt
		\normalsize
		\noindent % Änderung zur 
		 Ich erkläre an Eides statt, dass ich die vorliegende Diplomarbeit
		 selbstständig und ohne fremde Hilfe verfasst, andere als die angegebenen
		 Quellen und Hilfsmittel nicht benutzt und die den benutzten Quellen wörtlich und inhaltlich entnommenen
		 Stellen als solche erkenntlich gemacht habe.
        \vskip1.5in
        \foreach \n in \@author { \signature{Unterschrift:}{\n} \\
        \vskip 0.5in  
        }
    \end{quotation}
    \vfill\newpage\setcounter{page}{3}}

\def\beforepreface{
    \pagenumbering{roman}
    \pagestyle{plain}
    \titlep
    \iffront@pages
      \signaturepage
    \else
      \addtocounter{page}{1}
    \fi
    \iffront@pages
      \ifdedic@tion
        \newpage\begin{center}\Large\em\null\vskip1in
        \dedication@text
        \vfill\end{center}
      \fi
    \fi
    }


\def\prefacesection#1{%
    \chapter*{#1}
    \addcontentsline{toc}{chapter}{#1}}

\newenvironment{dedication}{\newpage\begin{center}\Large\em\null\vskip1in}%
{\vfill\end{center}}

\def\afterpreface{
	\iffront@pages
    \tableofcontents
  \else
    \addtocounter{page}{1}
  \fi
  \newpage
  \iffigurespage
      \listoffigures
      \newpage
  \fi
  \iftablespage
      \listoftables
      \newpage
  \fi
  \cleardoublepage
  \pagenumbering{arabic}
  \typeout{thesis preface pages completed.}
  \properpagestyle
}

% Redefine \thebibliography to go to a new page and put an entry in the
% table of contents
% \let\@ldthebibliography\thebibliography
% \renewcommand{\thebibliography}[1]{%
%     \newpage
%     \addcontentsline{toc}{chapter}{Bibliography}
%     \@ldthebibliography{#1}
% }
%
% \let\@ldbibliography\bibliography
% \renewcommand{\bibliography}[1]{\ifprint@bib\@ldbibliography{#1}\fi}


%Omit final dot from each def.
\def\eg{\latinabbrev{e.g},~}
\def\etc{\latinabbrev{etc}}
\def\ie{\latinabbrev{i.e},~}
\def\cf{\latinabbrev{cf}~}

\def\deg{\,^{\circ}}

%\addto\captionsenglish{\renewcommand{\figurename}{Fig.}}
%\addto\captionsngerman{\renewcommand{\figurename}{Abb.}}

% Start out normal
\properpagestyle

%\usepackage{htlchapter}

\usepackage{times}
\usepackage{multirow}

% Mathematical packages
\usepackage{amsmath}
\usepackage{amssymb}

\usepackage{color}
\usepackage{todonotes}
\usepackage{listings}

\usepackage{lineno}
\usepackage{xcolor}
\setlength\linenumbersep{5pt}
\renewcommand\linenumberfont{\normalfont\tiny\sffamily\color{gray}}

\usepackage{pdfcomment}
\usepackage[section]{placeins}

\usepackage[normalem]{ulem}
\usepackage[inline]{enumitem}
%\usepackage[applemac]{inputenc}

% Spacing after paragraph
\setlength{\parskip}{0.7em plus1pt minus1pt}
%\usepackage[parfill]{parskip}

% subsubsections numbered but not in TOC
\setcounter{secnumdepth}{4}
\setcounter{tocdepth}{5}

% Printing codes and pseudocode
\usepackage{algorithm}
\usepackage{algpseudocode}

\newcommand{\framefig}[1]{%
\setlength{\fboxrule}{0.1mm}%
\setlength{\fboxsep}{0mm}%
\fbox{#1}%
}



%Div. Abkürzungen (in Anlehnung an Jochen Köpperm, Wolfgang Schermann):
%\usepackage{xspace}

\newcommand{\bzgl}{bzgl.\@}
\newcommand{\bzw}{bzw.\@}
\newcommand{\ca}{ca.\@}
\newcommand{\dah}{d.\,h.\@}
\newcommand{\Dah}{D.\,h.\@}
\newcommand{\evtl}{evtl.\@}
\newcommand{\ia}{i.\,a.\@}

\newcommand{\ua}{u.\,a.\@}
\newcommand{\Ua}{U.\,a.\@}
\newcommand{\usw}{usw.\@}
\newcommand{\uva}{u.\,v.\,a.\@}
\newcommand{\uvm}{u.\,v.\,m.\@}
\newcommand{\va}{vor allem\@}
\newcommand{\vgl}{vgl.\@}
\newcommand{\zb}{z.\thinspace{}B.~\@}
\newcommand{\ZB}{Zum Beispiel~\@}

%Zeichen fuer die reellen, komplexen ... Zahlen (AMS Blackboard)
%\RequirePackage{amsfonts}
%\RequirePackage{amsbsy}
%\newcommand{\R}{\mathbb{R}}
%\newcommand{\Z}{\mathbb{Z}}
%\newcommand{\N}{\mathbb{N}}
%\newcommand{\C}{\mathbb{C}} // FIXME
%\newcommand{\Q}{\mathbb{Q}}

% Source Code Listings: minted package recommended but required additional
% programs, this simple listings package is used.
\usepackage[outputdir=build]{minted}
%Config for minted
\setmintedinline{bgcolor={},
breaklines=true,
breakbytokenanywhere,
breakafter=.}
\setminted{
breaklines=true,
breakbytokenanywhere,
frame=lines,
framesep=2mm,
baselinestretch=1.2,
bgcolor=lightgray,
fontsize=\small,
linenos,
tabsize=2
}
\usepackage{listings}
% \lstnewenvironment{LaTeXCode}	% code environment for Latex
% {\lstset{%
% 	language=[LaTeX]TeX,%
% 	commentstyle={},%
% 	texcl=false,%
% 	escapechar={},%
% %	escapeinside={},%
% 	escapeinside={/+}{+/}%
% %	mathescape=false,
% 	}}
{}

\addto\captionsenglish{%
  \renewcommand{\lstlistingname}%
	{Listing}%
}
\addto\captionsgerman{%
  \renewcommand{\lstlistingname}%
	{Quellcode}%
} 

% Commands for simpler Referencing
\usepackage{fancyref}
\newcommand\eqn[1]{\Frefeqname~\ref{eqn:#1}\@}
\newcommand\fig[1]{\figurename~\ref{fig:#1}\@}
\newcommand\lst[1]{\lstlistingname~\ref{lst:#1}\@}
\renewcommand\sec[1]{\Frefsecname~\ref{sec:#1}\@} 
% use renewcommand to
% overwrite \sec from Trigonometry
\newcommand\chp[1]{\chaptername~\ref{chp:#1}\@}
\newcommand\tbl[1]{\tablename~\ref{tbl:#1}\@}
\newcommand\alg[1]{\algorithmname~\ref{alg:#1}\@}

% Other helping commands
\newcommand\etal[1]{#1~\emph{\latinabbrev{et al}}~\@}
\newcommand{\ud}{\,\mathrm{d}}

%Omit final dot from each def.
\def\eg{\latinabbrev{e.g},~}
%\def\etal{\latinabbrev{et al}}
\def\etc{\latinabbrev{etc}}
\def\ie{\latinabbrev{i.e},~} 
\def\cf{\latinabbrev{cf}~}

\def\deg{\,^{\circ}}

%---------------------------------------------------
% lstlisting syntax highlighting and line numbering
% Source: https://www.overleaf.com/latex/examples/listings-code-style-for-html5-css-html-javascript/htstpdbpnpmt#.VrtmnFgrKUl
%---------------------------------------------------
% Define colors
\usepackage{color}
\definecolor{lightgray}{rgb}{0.95, 0.95, 0.95}
\definecolor{darkgray}{rgb}{0.4, 0.4, 0.4}
\definecolor{editorGray}{rgb}{0.95, 0.95, 0.95}
\definecolor{editorOcher}{rgb}{1, 0.5, 0} % #FF7F00 -> rgb(239, 169, 0)
\definecolor{editorGreen}{rgb}{0, 0.5, 0} % #007C00 -> rgb(0, 124, 0)
\definecolor{orange}{rgb}{1,0.45,0.13}
\definecolor{olive}{rgb}{0.17,0.59,0.20}
\definecolor{brown}{rgb}{0.69,0.31,0.31}
%\definecolor{purple}{rgb}{0.65, 0.12, 0.82}
\definecolor{purple}{rgb}{0.38,0.18,0.81}
\definecolor{lightblue}{rgb}{0.1,0.57,0.7}
\definecolor{lightred}{rgb}{1,0.4,0.5}
% CSS
\lstdefinelanguage{CSS}{
  keywords={color,background-image:,margin,padding,font,weight,display,position,top,left,right,bottom,list,style,border,size,white,space,min,width, transition:, transform:, transition-property, transition-duration, transition-timing-function},
  sensitive=true,
  morecomment=[l]{//},
  morecomment=[s]{/*}{*/},
  morestring=[b]',
  morestring=[b]",
  alsoletter={:},
  alsodigit={-}
}

% JavaScript
\lstdefinelanguage{JavaScript}{
  morekeywords={typeof, new, true, false, catch, function, return, null, catch, switch, var, if, in, while, do, else, case, break},
  morecomment=[s]{/*}{*/},
  morecomment=[l]//,
  morestring=[b]",
  morestring=[b]'
}

\lstdefinelanguage{HTML5}{
  language=html,
  sensitive=true,
  alsoletter={<>=-},
  morecomment=[s]{<!-}{-->},
  tag=[s],
  otherkeywords={
  % General
  >,
  % Standard tags
    <!DOCTYPE,
  </html, <html, <head, <title, </title, <style, </style, <link, </head, <meta, />,
    % body
    <body,
    </header, <header,
    </main, <main,
    </footer, <footer,
    </body,
    % Divs
    </div, <div, </div>,
    % Paragraphs
    </p, <p, </p>,
    % scripts
    </script, <script,
  % More tags...
  <canvas, /canvas>, <svg, <rect, <animateTransform, </rect>, </svg>, <video, <source, <iframe, </iframe>, </video>, <image, </image>, <header, </header, <article, </article
  },
  ndkeywords={
  % General
  =,
  % HTML attributes
  charset=, src=, id=, width=, height=, style=, type=, rel=, href=,
  % SVG attributes
  fill=, attributeName=, begin=, dur=, from=, to=, poster=, controls=, x=, y=, repeatCount=, xlink:href=,
  % properties
  margin:, padding:, background-image:, border:, top:, left:, position:, width:, height:, margin-top:, margin-bottom:, font-size:, line-height:,
    % CSS3 properties
  transform:, -moz-transform:, -webkit-transform:,
  animation:, -webkit-animation:,
  transition:,  transition-duration:, transition-property:, transition-timing-function:,
  }
}

\lstdefinestyle{htmlcssjs} {%
  % General design
%  backgroundcolor=\color{editorGray},
  basicstyle={\footnotesize\ttfamily},
  frame=b,
  % line-numbers
  xleftmargin={0.75cm},
  numbers=left,
  stepnumber=1,
  firstnumber=1,
  numberfirstline=true,
  % Code design
  identifierstyle=\color{black},
  keywordstyle=\color{blue}\bfseries,
  ndkeywordstyle=\color{editorGreen}\bfseries,
  stringstyle=\color{editorOcher}\ttfamily,
  commentstyle=\color{brown}\ttfamily,
  % Code
  language=HTML5,
  alsolanguage=JavaScript,
  alsodigit={.:;},
  tabsize=2,
  showtabs=false,
  showspaces=false,
  showstringspaces=false,
  extendedchars=true,
  breaklines=true,
  % German umlauts
  literate=%
  {Ö}{{\"O}}1
  {Ä}{{\"A}}1
  {Ü}{{\"U}}1
  {ß}{{\ss}}1
  {ü}{{\"u}}1
  {ä}{{\"a}}1
  {ö}{{\"o}}1
}
%
\lstdefinestyle{py} {%
language=python,
literate=%
*{0}{{{\color{lightred}0}}}1
{1}{{{\color{lightred}1}}}1
{2}{{{\color{lightred}2}}}1
{3}{{{\color{lightred}3}}}1
{4}{{{\color{lightred}4}}}1
{5}{{{\color{lightred}5}}}1
{6}{{{\color{lightred}6}}}1
{7}{{{\color{lightred}7}}}1
{8}{{{\color{lightred}8}}}1
{9}{{{\color{lightred}9}}}1,
basicstyle=\footnotesize\ttfamily, % Standardschrift
numbers=left,               % Ort der Zeilennummern
%numberstyle=\tiny,          % Stil der Zeilennummern
%stepnumber=2,               % Abstand zwischen den Zeilennummern
numbersep=5pt,              % Abstand der Nummern zum Text
tabsize=4,                  % Groesse von Tabs
extendedchars=true,         %
breaklines=true,            % Zeilen werden Umgebrochen
keywordstyle=\color{blue}\bfseries,
frame=b,
commentstyle=\color{brown}\itshape,
stringstyle=\color{editorOcher}\ttfamily, % Farbe der String
showspaces=false,           % Leerzeichen anzeigen ?
showtabs=false,             % Tabs anzeigen ?
xleftmargin=17pt,
framexleftmargin=17pt,
framexrightmargin=5pt,
framexbottommargin=4pt,
%backgroundcolor=\color{lightgray},
showstringspaces=false,      % Leerzeichen in Strings anzeigen ?
}
% Set default code style
\lstset{%
    % General design
    %backgroundcolor=\color{editorGray},
    basicstyle={\small\ttfamily},
    frame=l,
    % line-numbers
    xleftmargin={0.75cm},
    numbers=left,
    stepnumber=1,
    firstnumber=1,
    numberfirstline=true,
    postbreak=\raisebox{0ex}[0ex][0ex]{\ensuremath{\color{red}\hookrightarrow\space}},
    % Code design
    identifierstyle=\color{black},
    keywordstyle=\color{blue}\bfseries,
    ndkeywordstyle=\color{editorGreen}\bfseries,
    stringstyle=\color{editorOcher}\ttfamily,
    commentstyle=\color{darkgray}\ttfamily,
    % Code
    alsolanguage=JavaScript,
    alsodigit={.:;},
    tabsize=2,
    showtabs=false,
    showspaces=false,
    showstringspaces=false,
    extendedchars=true,
    breaklines=true,
    % German umlauts
    literate=%
    {Ö}{{\"O}}1
    {Ä}{{\"A}}1
    {Ü}{{\"U}}1
    {ß}{{\ss}}1
    {ü}{{\"u}}1
    {ä}{{\"a}}1
    {ö}{{\"o}}1
}

%Messbox zur Druckkontrolle:
\newcommand{\Messbox}[2]{% Parameters: #1=Breite, #2=Hoehe
\setlength{\unitlength}{1.0mm}%
\begin{picture}(#1,#2)%
\linethickness{0.05mm}%
\put(0,0){\dashbox{0.2}(#1,#2)%
{\parbox{#1mm}{%
\centering\footnotesize
%{\bf MESSBOX}\\
Breite $ = #1 {\rm\ mm}$\\
H\"ohe $ = #2 {\rm\ mm}$
}}}\end{picture}
}

\makeatletter
\renewcommand\paragraph{\@startsection{paragraph}{4}{\z@}%
  {-3.25ex\@plus -1ex \@minus -.2ex}%
  {1.5ex \@plus .2ex}%
  {\normalfont\normalsize\bfseries}}

\renewcommand\subparagraph{\@startsection{subparagraph}{5}{\z@}%
	{-3.25ex\@plus -1ex \@minus -.2ex}
	{1.5ex \@plus .2ex}%
	{\normalfont\normalsize}}
\makeatother


% Code formatting

\definecolor{base0}{RGB}{131,148,150}
\definecolor{base01}{RGB}{88,110,117}
\definecolor{base2}{RGB}{238,232,213}
\definecolor{sgreen}{RGB}{133,153,0}
\definecolor{sblue}{RGB}{38,138,210}
\definecolor{scyan}{RGB}{42,161,151}
\definecolor{smagenta}{RGB}{211,54,130}


\newcommand\digitstyle{\color{smagenta}}
\newcommand\symbolstyle{\color{base01}}
\makeatletter
\newcommand{\ProcessDigit}[1]
{%
  \ifnum\lst@mode=\lst@Pmode\relax%
   {\digitstyle #1}%
  \else
    #1%
  \fi
}
\makeatother


\lstdefinestyle{solarizedcsharp} {
  language=[Sharp]C,
  frame=lr,
  linewidth=160mm,
  breaklines=true,
  tabsize=2,
  numbers=left,
  numbersep=5pt,
  firstnumber=auto,
  numberstyle=\tiny\ttfamily\color{base0},
  rulecolor=\color{base2},
  basicstyle=\footnotesize\ttfamily,
  commentstyle=\color{base01},
  morecomment=[s][\color{base01}]{/*+}{*/},
  morecomment=[s][\color{base01}]{/*-}{*/},
  morekeywords={  abstract, event, new, struct,
                as, explicit, null, switch,
                base, extern, object, this,
                bool, false, operator, throw,
                break, finally, out, true,
                byte, fixed, override, try,
                case, float, params, typeof,
                catch, for, private, uint,
                char, foreach, protected, ulong,
                checked, goto, public, unchecked,
                class, if, readonly, unsafe,
                const, implicit, ref, ushort,
                continue, in, return, using,
                decimal, int, sbyte, virtual,
                default, interface, sealed, volatile,
                delegate, internal, short, void,
                do, is, sizeof, while,
                double, lock, stackalloc,
                else, long, static,
                enum, namespace, string, var},
  keywordstyle=\bfseries\color{sgreen},
  showstringspaces=false,
  stringstyle=\color{scyan},
  identifierstyle=\color{sblue},
  extendedchars=true,
  escapeinside={»ESCAPE«}{»UNESCAPE«},
  % literate=
  %   {0}{{{\ProcessDigit{0}}}}1
  %   {1}{{{\ProcessDigit{1}}}}1
  %   {2}{{{\ProcessDigit{2}}}}1
  %   {3}{{{\ProcessDigit{3}}}}1
  %   {4}{{{\ProcessDigit{4}}}}1
  %   {5}{{{\ProcessDigit{5}}}}1
  %   {6}{{{\ProcessDigit{6}}}}1
  %   {7}{{{\ProcessDigit{7}}}}1
  %   {8}{{{\ProcessDigit{8}}}}1
  %   {9}{{{\ProcessDigit{9}}}}1
  %   {\}}{{\symbolstyle{\}}}}1
  %   {\{}{{\symbolstyle{\{}}}1
  %   {=}{{\symbolstyle{$=$}}}1
  %   {;}{{\symbolstyle{$;$}}}1
  %   {>}{{\symbolstyle{$>$}}}1
  %   {<}{{\symbolstyle{$<$}}}1
  %   {\%}{{\symbolstyle{$\%$}}}1,
}

\lstset{style=solarizedcsharp}
